poj-1177 Picture(矩形周长并,线段树+扫描线)

题目链接:点击打开链接

Picture

Time Limit: 2000MS   Memory Limit: 10000K
Total Submissions: 11706   Accepted: 6175

Description

A number of rectangular posters, photographs and other pictures of the same shape are pasted on a wall. Their sides are all vertical or horizontal. Each rectangle can be partially or totally covered by the others. The length of the boundary of the union of
all rectangles is called the perimeter.

Write a program to calculate the perimeter. An example with 7 rectangles is shown in Figure 1.

The corresponding boundary is the whole set of line segments drawn in Figure 2.

The vertices of all rectangles have integer coordinates.

Input

Your program is to read from standard input. The first line contains the number of rectangles pasted on the wall. In each of the subsequent lines, one can find the integer coordinates of the lower left vertex and the upper right vertex of each rectangle. The
values of those coordinates are given as ordered pairs consisting of an x-coordinate followed by a y-coordinate.

0 <= number of rectangles < 5000

All coordinates are in the range [-10000,10000] and any existing rectangle has a positive area.

Output

Your program is to write to standard output. The output must contain a single line with a non-negative integer which corresponds to the perimeter for the input rectangles.

Sample Input

7
-15 0 5 10
-5 8 20 25
15 -4 24 14
0 -6 16 4
2 15 10 22
30 10 36 20
34 0 40 16

Sample Output

228

题意:平面上有很多个矩形,矩形间会相互覆盖,问总的周长是多少。

思路:看到这道题就想到之前做过的矩形面积并,这道题比那道题要多处理一个横边,除此之外就都一样了~ 看了点击打开链接这位大神的思路后豁然开朗。

在之前的矩形面积并模板上改了下AC了,代码的具体打了注释,看代码吧。

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
#define N 10010
struct Node
{
    int l,r;
    int rl,rr;
    int c;///线段的权值,入边为1,出边为-1
    int cnt;///垂直方向有效长度
    int part;///在垂直方向有效段有几个区间,连续的两个区间算一个。
    int isl,isr;///区间左端点和右端点是否被覆盖
}tree[N<<2];
struct Line
{
    int x;
    int y1,y2;
    int c;
} line[N<<1];
int y[N];
bool cmp(Line a,Line b)
{
    if(a.x==b.x)
        return a.c>b.c;///注意不管是poj还是hdu这一步不加都是可以AC的,但是代码却是错的,因为无法判断重边。有重边的情况下,先判断入边再判断出边即可解决。
    return a.x<b.x;
}
void build(int root,int l,int r)
{
    tree[root].l=l;
    tree[root].r=r;
    tree[root].rl=y[l];
    tree[root].rr=y[r];
    tree[root].c=0;
    tree[root].cnt=0;
    tree[root].part=0;
    tree[root].isl=tree[root].isr=0;
    if(l+1==r)
        return;
    int m=(l+r)>>1;
    build(root<<1,l,m);
    build(root<<1|1,m,r);
}
void pushup(int root)
{
    if(tree[root].c>0)
    {
            tree[root].cnt=tree[root].rr-tree[root].rl;
            tree[root].isl=tree[root].isr=1;
            tree[root].part=1;
    }
    else
    {

        if(tree[root].l+1==tree[root].r)
        {
            tree[root].cnt=0;
            tree[root].isl=tree[root].isr=0;
            tree[root].part=0;
        }
        else
        {
            tree[root].cnt=tree[root<<1].cnt+tree[root<<1|1].cnt;
            tree[root].isl=tree[root<<1].isl;
            tree[root].isr=tree[root<<1|1].isr;
            tree[root].part=tree[root<<1].part+tree[root<<1|1].part-tree[root<<1].isr*tree[root<<1|1].isl;
        }
    }
}
void update(int root,Line a)
{
    if(tree[root].rl==a.y1&&tree[root].rr==a.y2)
    {
        tree[root].c+=a.c;
        pushup(root);
        return;
    }
    if(a.y2<=tree[root<<1].rr)
    {
        update(root<<1,a);
    }
    else if(a.y1>=tree[root<<1|1].rl)
    {
        update(root<<1|1,a);
    }
    else
    {
        Line temp=a;
        temp.y2=tree[root<<1].rr;
        update(root<<1,temp);
        temp=a;
        temp.y1=tree[root<<1|1].rl;
        update(root<<1|1,temp);
    }
    pushup(root);
}
int main()
{
    int x1,y1,x2,y2;
    int n;
    int flag=0;
    while(~scanf("%d",&n))
    {
        if(flag==1)
            break;
        int t=1;
        for(int i=0;i<n;i++)
        {
            scanf("%d %d %d %d",&x1,&y1,&x2,&y2);
            line[t].x=x1;
            line[t].y1=y1;
            line[t].y2=y2;
            line[t].c=1;
            y[t++]=y1;
            line[t].x=x2;
            line[t].y1=y1;
            line[t].y2=y2;
            line[t].c=-1;
            y[t++]=y2;
        }///保存每条边和每一个y值
        sort(line+1,line+t,cmp);
        sort(y+1,y+t);
        int num=2;
        for(int i=2;i<t;i++)
            if(y[i]!=y[i-1])
            y[num++]=y[i];///去重
        build(1,1,num-1);
        update(1,line[1]);
        int sum=tree[1].cnt;
        int last_part=tree[1].part;
        int last_cnt=tree[1].cnt;///预处理第一条边,因为后面需要先更新后处理
        for(int i=2;i<t;i++)
        {
            update(1,line[i]);
            sum+=abs(tree[1].cnt-last_cnt);///当新进来一条线段的时候,用更新完的有效长度减去更新前的有效长度即可得出“不是在内部的边的长度”,这点和矩形面积并相反,面积并需要的恰是在内部的边的长度
            sum+=2*last_part*(line[i].x-line[i-1].x);///求出横边,一段(区间)有两条边。注意要用更新之前的part值,应该很容易理解。横边的条数是从左边看到右边的,即我们能确保的只有上一个x到当前x之前的这段距离有更新前的段数*2的边长
            last_part=tree[1].part;
            last_cnt=tree[1].cnt;///滚动
        }
        printf("%d\n",sum);
    }
    return 0;
}
时间: 2024-10-28 16:11:20

poj-1177 Picture(矩形周长并,线段树+扫描线)的相关文章

POJ 2482 Stars in Your Window 线段树扫描线

Stars in Your Window Description Fleeting time does not blur my memory of you. Can it really be 4 years since I first saw you? I still remember, vividly, on the beautiful Zhuhai Campus, 4 years ago, from the moment I saw you smile, as you were walkin

【POJ】1171 求矩形并的周长(线段树+扫描线+离散化)

#define _CRT_SECURE_NO_WARNINGS #include<iostream> #include<cstring> #include<algorithm> #include<cstdio> #include<cmath> using namespace std; #define MAX 10010 #define ls rt<<1 #define rs ls|1 #define m (r+l)>>1

hdu1255 覆盖的面积 线段树-扫描线

矩形面积并 线段树-扫描线裸题 1 #include<stdio.h> 2 #include<string.h> 3 #include<algorithm> 4 #include<math.h> 5 using namespace std; 6 const int maxm=2e3+5; 7 const double eps=1e-5; 8 9 struct seg{ 10 double x,y1,y2; 11 int c; 12 bool operator

hdu1828 (Picture) &amp;poj 1177( Picture)&amp;sdibt 2390(5.5.1 Picture 矩形周长)(线段树+扫描)

题目地址:hdu1828 (Picture)  & poj 1177( Picture) & sdibt 2390(5.5.1 Picture 矩形周长) 题目大意: 给你N个矩形,求出N个矩形构成的周长. 解题思路: 线段数+扫描线. 推荐博客: POJ1177 Picture(线段树求轮廓周长) POJ 1177 Picture (线段树+离散化+扫描线) 详解 注意事项: 该题在求面积的基础上有了升级,多写了一个被调需要求出投影与Y轴有几段,不然样例会少算20,就是给出图形中间的小矩

poj 1177 Picture(扫描线+矩形周长并)

http://poj.org/problem?id=1177 求矩形的周长并,明确的一点是对于覆盖的边的长度忽略不计. 与求面积并类似,首先离散化,对矩形的每条横边从下往上扫描.扫描过程中要完成三个任务,更新相应的区间信息,求横边长,求竖边长. 节点信息: l,r:左右区间编号 cnt:表示该区间是否被完全覆盖.cnt > 0 表示完全覆盖,否则不完全覆盖. lp,rp:表示该区间的两个端点是否被覆盖,为1被覆盖,为0没被覆盖. num:该区间被覆盖的线段数目.例如区间[1,10],当更新[2,

[线段树扫描线][USACO5.5]矩形周长Picture

墙上贴着许多形状相同的海报.照片.它们的边都是水平和垂直的.每个矩形图片可能部分或全部的覆盖了其他图片.所有矩形合并后的边长称为周长. 所有矩形的边界.所有矩形顶点的坐标都是整数. 输入文件的第一行是一个整数N(0<=N<5000),表示有多少个矩形.接下来N行给出了每一个矩形左下角坐标和右上角坐标(所有坐标的数值范围都在-10000到10000之间). 输出文件只有一个正整数,表示所有矩形的周长. 题解 线段树扫描线  https://www.luogu.org/problemnew/sol

hdu 1828 Picture(线段树&amp;扫描线&amp;周长并)

Picture Time Limit: 6000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2578    Accepted Submission(s): 1363 Problem Description A number of rectangular posters, photographs and other pictures of the same shap

POJ 1177 Picture(扫描线求周长)

与求面积并的差不多,但是这个与扫描的方向相同的情况不太好处理,如果扫描线离散化两次扫两遍其实也可以解决这个问题,但是这样无论在时间还是空间上稍微就有点浪费了啊.这里因为我是离散x坐标的所以对于平行于y轴的方向上的统计比较难统计.处理的方法是:标记区间左边的断点,和右边的断点,求出这个区间一共有多少个断点.就可以统计出平行于y轴的长度了.这里合并的时候需要判断右边的左区间和左边的右区间是否相同,如果相同的话,说明他们连接到了一起,要减去多加的. Picture Time Limit: 2000MS

poj 3277 City Horizon (线段树 扫描线 矩形面积并)

题目链接 题意: 给一些矩形,给出长和高,其中长是用区间的形式给出的,有些区间有重叠,最后求所有矩形的面积. 分析: 给的区间的范围很大,所以需要离散化,还需要把y坐标去重,不过我试了一下不去重 也不会出错, 所有的区间都能列出来,只是在查找的时候费点事. 给的矩形相当于在同一水平线上的,也就是y1坐标相当于为0,其他的就和 poj 1151 Atlantis 差不多了. 我写的思路是按照矩形面积并的思路写的: 但是还有另一种方法也是挺简单的,就是把给的矩形按照高从小到大排序,然后依次插入线段树

poj 1151 求矩形面积并 (线段树扫描线)

题意: 给出n个矩形的左下角和右上角坐标,求这n个矩形所构成的面积 思路: 线段树扫描线 这是第一次做到线段树扫描线,刚开始也不懂 如果不懂,可以看: http://www.cnblogs.com/scau20110726/archive/2013/04/12/3016765.html 和 http://www.faceye.net/search/69289.html 我是看第一个链接弄懂的 然后学习了第二位的方法 代码上也有比较详细的注释,想可以帮到大家 code: #include<cstd